import { Extension, onLoadDocumentPayload } from '@hocuspocus/server';
import { LeveldbPersistence } from 'y-leveldb';
export interface Configuration {
    options: object | undefined;
    path: string;
}
export declare class RocksDB implements Extension {
    configuration: Configuration;
    provider: LeveldbPersistence;
    /**
     * Constructor
     */
    constructor(configuration?: Partial<Configuration>);
    /**
     * onLoadDocument hook
     */
    onLoadDocument(data: onLoadDocumentPayload): Promise<any>;
    /**
     * store updates in y-leveldb persistence
     */
    store(documentName: string, update: Uint8Array): Promise<any>;
}
